"""Base prompting output class."""

from agential.core.base.output import BaseOutput


class BasePromptingOutput(BaseOutput):
    """Base class for structured prompting method outputs.

    Attributes:
        answer (str): The answer generated by the prompting method.
        total_prompt_tokens (int): The total number of input tokens used.
        total_completion_tokens (int): The total number of output tokens used.
        total_tokens (int): The total number of tokens used.
        total_cost (float): The total cost of the output.
        total_prompt_cost (float): The total cost of the prompt tokens.
        total_completion_cost (float): The total cost of the completion tokens.
        total_prompt_time (float): The total time taken for the LLM API to generate the outputs in seconds.
        total_time (float): The total time for the prompting method to finish generating in seconds.
        additional_info (Any): A general attribute for additional information.
    """

    pass
